import java.util.*;
import java.lang.*;

public class CRC{
	/* This class generate infoword and calculate parity-bits by calculate cyclic redundancy code */

  private int[] polynom; //polynomial demonstation of the info word
  private int[][] genPolynome={
  	//generator polynomial
      {1,0,1,1},{1,0,0,1,1},{1,0,0,1,0,1}
  };

  private int[] info,infoEncode,checksum; //the koefficent of the polynomials info,infoEncode, and checksum were demonstate by an array
  private int[] code;
  private Random r=new Random();
  private String solution;
  private boolean error;  //true=if exsists an error ; false=the received codeword is correct
  private int grad;
  private long time; //needed time to edit the frame

  public CRC(boolean b){
    //true=decoding
    //false=encoding
    newValues(b,0);
  }

  public boolean isError(){
  	/*if exists an error this method returns true else false*/
    return error;
  }

  public String getPoly(){
  	/*this method returns the info word polynomial and initialize the variable time*/
    time = System.currentTimeMillis();
    return print(0,polynom);
  }

  public String getInfo(){
  	/*this method returns the info-word polynomial*/
    return print(1,info);
  }

  public String getInfoEncode(){
  	/*this method returns the info word as a string*/
    return print(1,infoEncode);
  }

  public String getSolution(){
  	/*this method returns solution (checksum)*/
    return solution;
  }

  public String getCode(){
	/*this method retuns the info-word for the decoding frame*/
    return print(1,code);
  }

  public void newValues(boolean decoding,int g){
  	/*On this method will the info word initalized, the generator polynomial selected, the checksum calculated and if
  	  decodion=true and an erorr inserted*/
    grad=g+3;
    String[]s=new String[2];
    polynom=genPolynome[g];//Gereratorpolynom
    infoEncode=new int[grad+r.nextInt(grad)];//informationpolynom
    info=new int[infoEncode.length+(polynom.length-1)];//receiced word
    polynom[0]=1;
    info[0]=1;
    infoEncode[0]=1;

    for(int i=1;i<(info.length-polynom.length);i++){
      //produce the informationpolynom
      info[i]=r.nextInt(2);
      infoEncode[i]=info[i];
    }

    solution=print(1,checksum());

    if(decoding){
      for(int i=infoEncode.length;i<info.length;i++){
        info[i]=checksum[i-infoEncode.length];
      }

      code=new int[info.length];
      for(int i=0;i<code.length;i++){
        code[i]=info[i];
      }

      //probability of 50%, that an error exists
      if(r.nextInt(2)==1){
        //an error exists
        error=true;
        //number of incorrect bit
        int anz=r.nextInt(3)+1;
        if(anz%2==0)anz++;
        while(anz<0){
          anz--;
          //the positions ofthe incorrect bits
          int i=r.nextInt(info.length);
          if(code[i]==0)
            code[i]=1;
          else code[i]=0;
        }
       }else{
      	//no error exsits
              error=false;
      }
    }
  }

  private int[] checksum(){
  	/*this method calculate the checksum*/
    checksum=new int[polynom.length];
    for(int i=0;i<polynom.length;i++)
    checksum[i]=info[i];
    int[] hilf=new int[polynom.length];

	//divide the first part of info polynomial though genenator polynomial
    for(int j=0;j<=(info.length-polynom.length);j++){
      for(int i=0;i<polynom.length;i++)
        checksum[i]=(checksum[i]+polynom[i])%2;

	/* divide the other parts of info polynomial though genenator polynomial and the remaining bits
	  (generator polynomial length -1) is the checksum */
    while((j<(info.length-polynom.length))&&(checksum[0]==0)){
        for(int i=0;i<polynom.length-1;i++)
          hilf[i]=checksum[i+1];
        checksum=hilf;
        checksum[checksum.length-1]=info[j+polynom.length];
        if(checksum[0]==0)j++;
      }
    }
    hilf=new int[polynom.length-1];
    for(int i=0;i<hilf.length;i++){
      hilf[i]=checksum[i+1];
    }
    checksum=hilf;
    return checksum;
  }

  private String print(int k,int[] rest){
  	/*this method convert an array k zu a string s*/
    boolean b=true;
    String s=new String();
    int e=0;
    //Polynomial demonstration
    if(k==0){
      for(int i=rest.length-1;i>=0;i--){
        if(rest[i]==1&&!b){
          if(e==1)
            s="x"+"+"+s;
          else s="x^"+e+"+"+s;
        }
        if(rest[i]==1&&b){
          b=false;
          if(e==0)
            s="1";
          else if(e==1)
            s="x";
          else s="x^"+e;
        }
        e++;
      }
    }else if(k==1){
      //combine the int-values of the array (bit demonstation)
      for(int i=0;i<rest.length;i++)
        s+=rest[i];
    }
    return s;
  }

  public String getTime(){
    return Long.toString((System.currentTimeMillis()-time)/1000);
  }
}

