import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.*;
import javax.swing.border.*;

public class CRCGUI extends JFrame{
	/* This class shows the error-correction-mechanism cyclic redundancy code */

  private Status state;		//reference on class Status
  private final String akt="CRCGUI";		//id of this class
  private int myDifficultyEnc,myDifficultyDec; 	//this variabes contains current difficulty level (encoding and decoding)

  private Container myFrame;
  private JPanel p1,p1p1,p1p2; //exercise-panel
  private JPanel p2,p2p1,p2p2;	//solutin-panel
  private JPanel leiste;	//button-ledge
  private Border border1,border2; //border of exercise-panel and soluton-panel
  private JTabbedPane jTabbedPaneEncDec; 	//Tabbedpane for encoding and decoding
  private JButton b1,b2,b3,b4,b5,b6; //new-, test-, soluion-, back-, next-, menu- and circoverview-button
  private JLabel l1,l2,l2l,l3,l3l,l4,l5,l6,l7,l8,l9,l10,l11,l12;
  private CRC enCode,deCode;	//reference on class CRC to calculate and test the solution
  private JTextField t1,t2,t3,t4,t5;
  private ImageIcon right,wrong; //have user calculate right show icon right else show icon wrong
  private ButtonGroup group;	//either press radion-button r1 or r2 but not both at the same time
  private JRadioButton r1,r2;

  private JPanel p1p3,p2p3;
  private JLabel sendReturn,sendReturndec;	//show the current values difficulty,valuation and time or the answer of the server
  private JButton send,senddec;		//press this button and the values will send
  private TitledBorder tb3;

  private JMenuBar menuBar;
  private JMenu m1, m2,m3,m4,m5;
  private JMenuItem m11,m12,m21,m22,m31,m41,m51,m52;

  public CRCGUI(Status st,Image r,Image w){
    super("CRC");

    state=st;
    myDifficultyEnc=0;
    myDifficultyDec=0;
    wrong=new ImageIcon(w);
    right=new ImageIcon(r);

    myFrame=getContentPane();
    myFrame.setLayout(new BorderLayout());

    setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    menubar();

//encoding

    //exercise-part
    p1=new JPanel();
    p1.setLayout(null);

    p1p1=new JPanel();
    p1p1.setLayout(null);
    p1p1.setBounds(0,0,485,270);
    border1=BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
    TitledBorder tb1=new TitledBorder(border1,"Exercise");
    tb1.setTitleColor(Color.black);
    p1p1.setBorder(tb1);

    l1=new JLabel("Compute the checksum! ");
    l1.setForeground( Color.black );
    l1.setBounds(20,50,200,20);
    p1p1.add(l1);

    enCode=new CRC(false);

    l2=new JLabel("information word         = ");
    l2.setBounds(20,110,150,20);
    l2.setForeground( Color.black );
    p1p1.add(l2);

    t1=new JTextField(enCode.getInfoEncode());		//this textfield shows the info word
    t1.setBounds(170,110,260,20);
    p1p1.add(t1);

    l3=new JLabel("generator polynomial = ");
    l3.setBounds(20,150,150,20);
    l3.setForeground( Color.black );
    p1p1.add(l3);

    t2=new JTextField(enCode.getPoly());	//this textfield shows the generator polynomial
    t2.setBounds(170,150,260,20);
    p1p1.add(t2);

    b1=new JButton("New");		//new-button
    b1.setBounds(200,200,80,25);
    b1.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        newValues();
      }
    });
    p1p1.add(b1);

    p1.add(p1p1);

    //Solution-part
    p1p2=new JPanel();
    p1p2.setLayout(null);
    p1p2.setBounds(0,275,485,200);
    TitledBorder tb2=new TitledBorder(border1,"Solution");
    tb2.setTitleColor(Color.black);
    p1p2.setBorder(tb2);

    l4=new JLabel("checksum           = ");
    l4.setBounds(20,60,150,20);
    l4.setForeground( Color.black );
    p1p2.add(l4);

    t3=new JTextField();	//the user should enter the solution on this textfield
    t3.setBounds(170,60,220,20);
    p1p2.add(t3);

    l5=new JLabel();
    l5.setBounds(410,50,40,40);
    right=new ImageIcon(r);
    wrong=new ImageIcon(w);
    p1p2.add(l5);

    b2=new JButton("Test");		//test-button
    b2.setBounds(110,140,80,25);
    b2.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        send.setEnabled(true);
        if((enCode.getSolution()).equals(t3.getText())){
          b3.setEnabled(false);
          b2.setEnabled(false);
          l5.setIcon(right);
          l5.setVisible(true);
          state.setValuation(akt,1);	//increase the valuation
          state.setDifficulty(akt,1);	//increase the difficulty
          if(myDifficultyEnc<2){	//the variable myDifficulty may increase only 2 times
            myDifficultyEnc++;
          }
        }else{
          l5.setIcon(wrong);
          l5.setVisible(true);
          state.setValuation(akt,-1);	//degrease the difficulty
        }
        state.setTime(akt,enCode.getTime());		//compute the needed time an notice the value
      }
    });
    p1p2.add(b2);

    b3=new JButton("Solution");		//solution-button
    b3.setBounds(250,140,80,25);
    b3.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        b2.setEnabled(false);
        l6.setText("The solution is "+enCode.getSolution());
      }
    });
    p1p2.add(b3);

    l6=new JLabel();
    l6.setBounds(170,90,200,20);
    l6.setForeground( Color.blue );
    p1p2.add(l6);

    p1.add(p1p2);

    //Online-part
    p1p3=new JPanel();
    p1p3.setBounds(0,480,485,80);
    p1p3.setLayout(null);
    tb3=new TitledBorder(border1,"Online");
    tb3.setTitleColor(Color.black);
    p1p3.setBorder(tb3);

    send=new JButton("Send"); 	//send-button
    send.setEnabled(false);
    send.setBounds(50,30,80,25);
    send.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        sendReturn(state.send(akt));
      }
    });
    p1p3.add(send);

    sendReturn=new JLabel();
    sendReturn.setForeground(Color.blue);
    sendReturn.setBounds(160,30,280,25);
    p1p3.add(sendReturn);
    p1.add(p1p3);


//Decoding
    //Exercise-Decoding
    p2=new JPanel();
    p2.setLayout(null);


    p2p1=new JPanel();
    p2p1.setLayout(null);
    p2p1.setBounds(0,0,485,270);
    p2p1.setBorder(tb1);

    l7=new JLabel("Was the codeword received correctly? ");
    l7.setForeground( Color.black );
    l7.setBounds(20,50,300,20);
    p2p1.add(l7);

    deCode=new CRC(true);

    l8=new JLabel("generator polynomial  = ");
    l8.setBounds(20,110,150,20);
    l8.setForeground( Color.black );
    p2p1.add(l8);

   	t4=new JTextField(deCode.getPoly());	//this textfield shows the generator polynomial
    t4.setBounds(170,110,260,20);
    p2p1.add(t4);

    l9=new JLabel("received word  = ");
    l9.setBounds(20,150,150,20);
    l9.setForeground( Color.black );
    p2p1.add(l9);

    t5=new JTextField(deCode.getCode());	//this textfield shows the received info word incl. parity-bits
    t5.setBounds(170,150,260,20);
    p2p1.add(t5);

    b4=new JButton("New");		//new-button
    b4.setBounds(200,215,80,25);
    b4.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        newValues();
      }
    });
    p2p1.add(b4);
    p2.add(p2p1);

    //Solution-Decoding-part
    p2p2=new JPanel();
    p2p2.setLayout(null);
    p2p2.setBounds(0,275,485,200);

    p2p2.setBorder(tb2);

	//does an error occor
    r1=new JRadioButton(" YES ");
    r1.setSelected(true);
    r2=new JRadioButton(" NO ");
    group = new ButtonGroup();
    group.add(r1);
    group.add(r2);
    JPanel radioPanel = new JPanel();
    radioPanel.setBounds(40,40,100,80);
    radioPanel.setLayout(new GridLayout(0, 1));
    radioPanel.add(r1);
    radioPanel.add(r2);
    p2p2.add(radioPanel);

    l11=new JLabel();
    l11.setBounds(180,60,40,40);
    l11.setVisible(false);
    p2p2.add(l11);

    b5=new JButton("Test");		//test-button
    b5.setBounds(280,70,80,25);
    b5.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        senddec.setEnabled(true);
        state.setTime(akt,deCode.getTime());
    	b5.setEnabled(false);
        if((!deCode.isError()&&r1.isSelected())||
           (deCode.isError()&&r2.isSelected())){
          l11.setIcon(right);
          l11.setVisible(true);
          b5.setEnabled(false);
          b6.setEnabled(false);
          r1.setEnabled(false);
          r2.setEnabled(false);
          state.setValuation(akt,1);
          state.setDifficulty(akt,1);
          if(myDifficultyDec<2)
            myDifficultyDec++;
        }else{
          l11.setIcon(wrong);
          l11.setVisible(true);
          state.setValuation(akt,-1);
        }
        state.setTime(akt,deCode.getTime());	//calculate the time, that user have needed to calculate solution
      }
    });
    p2p2.add(b5);

    b6=new JButton("Solution");		//solution-button
    b6.setBounds(40,150,80,25);
    b6.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        if(deCode.isError())
          l12.setText("No, the received codeword is incorrect!");
        else l12.setText("Yes, the received codeword is correct!");
        l12.setVisible(true);
        b5.setEnabled(false);
        b5.setEnabled(false);
        r1.setEnabled(false);
        r2.setEnabled(false);
      }
    });
    p2p2.add(b6);

    l12=new JLabel();
    l12.setBounds(160,150,300,20);
    l12.setForeground( Color.blue );
    p2p2.add(l12);

    p2.add(p2p2);

    //Online-part
    p2p3=new JPanel();
    p2p3.setBounds(0,480,485,80);
    p2p3.setLayout(null);
    p2p3.setBorder(tb3);

    senddec=new JButton("Send");	//send-button-decoding
    senddec.setBounds(40,30,80,25);
    senddec.setEnabled(false);
    senddec.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.send(akt);
      }
    });
    p2p3.add(senddec);

    sendReturndec=new JLabel();
    sendReturndec.setForeground(Color.blue);
    sendReturndec.setBounds(160,30,280,25);
    p2p3.add(sendReturndec);
    p2.add(p2p3);

    //TabbedPane
    jTabbedPaneEncDec=new JTabbedPane ();
    myFrame.add(jTabbedPaneEncDec,BorderLayout.CENTER);
    jTabbedPaneEncDec.add(p1,"Encoding");
    jTabbedPaneEncDec.add(p2,"Decoding");

    //Buttonledge
    leiste=new JPanel();
    leiste.setBorder( BorderFactory.createRaisedBevelBorder() );

    JButton b4=new JButton("Back"); 	//back-button
    b4.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.lastState(akt);
      }
    });
    leiste.add(b4);

    JButton b5=new JButton("Next");		//next-button
    b5.setEnabled(false);
    leiste.add(b5);

    JButton b6=new JButton("Menu");		//menu-button
    b6.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showMenu(akt);
      }
    });
    leiste.add(b6);

    myFrame.add(leiste,BorderLayout.SOUTH);
  }

  private void newValues(){
  	/* this method generates new values and shows them on the frame  */
    if(jTabbedPaneEncDec.getSelectedIndex()==0){
    	//new-button-encodion was pressed
      b2.setEnabled(true);
      b3.setEnabled(true);
      l5.setVisible(false);
      t3.setText("");
      l6.setText("");
      enCode.newValues(false,myDifficultyEnc);
      t1.setText(enCode.getInfoEncode());
      t2.setText(enCode.getPoly());
    }else{
    	//new-button-decodion was pressed
      b5.setEnabled(true);
      b6.setEnabled(true);
      r1.setEnabled(true);
      r2.setEnabled(true);
      l11.setVisible(false);
      l12.setVisible(false);
      deCode.newValues(true,myDifficultyDec);
      t4.setText(deCode.getPoly());
      t5.setText(deCode.getCode());
    }

  }
  public void sendReturn(String s){
  	/* this method shows the feedback either from class Status or from the server  */
    if(jTabbedPaneEncDec.getSelectedIndex()==0){
      sendReturn.setText(s);
      sendReturndec.setText("");
    }else{
      sendReturndec.setText(s);
      sendReturn.setText("");
    }
  }

  private void menubar(){

    //insert menuBar
    menuBar=new JMenuBar();
    m1=new JMenu("File");
    m2=new JMenu("View");
    m3=new JMenu("Menu");
    m4=new JMenu("Circ-Overview");
    m5=new JMenu("?");

    m11=new JMenuItem("New");
    m11.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        newValues();
      }
    });
    m1.add(m11);
    m1.addSeparator();

    m12=new JMenuItem("Quit");
    m12.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.close(akt);
      }
    });
    m1.add(m12);

    menuBar.add(m1);

    m21=new JMenuItem("Back");
    m21.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.lastState(akt);
      }
    });
    m2.add(m21);
    m2.addSeparator();

    m22=new JMenuItem("Next");
    m22.setEnabled(false);
    m2.add(m22);

    menuBar.add(m2);

    m31=new JMenuItem("Menu");
    m31.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showMenu(akt);
      }
    });
    m3.add(m31);

    menuBar.add(m3);

    m41=new JMenuItem("Circ-Overview");
    m41.setEnabled(false);
    m4.add(m41);

    menuBar.add(m4);

    m51=new JMenuItem("Help");
    m51.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        state.showHelp(akt,jTabbedPaneEncDec.getSelectedIndex());
      }
    });
    m5.add(m51);
    m5.addSeparator();

    m52=new JMenuItem("<html>GF(2<SUP>4</SUP>)</html>");
    m52.setEnabled(false);
    m5.add(m52);

    menuBar.add(m5);
    setJMenuBar(menuBar);
  }
}
