import java.lang.*;
import java.util.*;

public class ProductCode{

	private int[][] gen={ 	
					{1,1,0},
					{1,0,1},
					{0,1,1},
					{1,1,1}
				};
	private int[][] gens={ 	//SYSTEMATISCH
					{1,0,0,0,1,1,0},
					{0,1,0,0,1,0,1},
					{0,0,1,0,0,1,1},
					{0,0,0,1,1,1,1}
				};			
	private int[][] info;
				
	private int[][] t={	
	            {0,0,0,0,1,0,0},
				{0,0,0,0,0,1,0},
				{1,0,0,0,0,0,0},
				{0,0,0,0,0,0,1},
				{0,1,0,0,0,0,0},
				{0,0,1,0,0,0,0},
				{0,0,0,1,0,0,0}
				};			
			
	private int[][] p;
	private int[][] q;
	private int[][] sol,sols;
	private int[][] solution,solutionDec;
	private int[] wp,wq;
	private boolean[][] errorPos;
	private long time;			
		
	public int[][] getInfo(){
		/*this method generate the information words(4 * 4bit) and caluculate
		  p- and q-parity*/

		Random r=new Random();
		int[][] info=new int[4][4];
		for(int i=0;i<4;i++){
			for(int j=0;j<4;j++){
				info[i][j]=r.nextInt(2);
			}
		}
		this.info=info;
		p=calcParity(this.info,gen);
		q=trans(calcParity(trans(calcParity(this.info,gens)),gen));
		solution=trans(calcParity(trans(calcParity(this.info,gens)),gens));  //the whole matrix incl. p-/q-parity
		time = System.currentTimeMillis();  	//on this time starts the user to solve the exercise
		return this.info;
	}
	
	public int[][] getInfoDec(int nrError){
		/*this method fit in "nrError" numbers of errors into the 7 7bit words*/
		nrError++;
		int[][] hilf=new int[7][7];
		getInfo();	//generate the info-matrix with p-/q-parity   
		Random r=new Random();
		errorPos=new boolean[7][7];	//notice the incorrect array position
		for(int i=0;i<7;i++){
			for(int j=0;j<7;j++){
				hilf[i][j]=solution[i][j];
				errorPos[i][j]=true;	
			}
		}				
		while(nrError>0){
			//generate error positions until nrError=0
			int i=r.nextInt(7);
			int j=r.nextInt(7);
			errorPos[i][j]=false;
			hilf[i][j]++;
			hilf[i][j]%=2;
			nrError--;
		}
		return hilf;
	}
	
	public int[][] testDec(boolean[][] b){
		/*if the user found the error, this method checks if the solution is right */
		int[][] hilf=new int[7][7];
		for(int i=0;i<7;i++){
			for(int j=0;j<7;j++){
				if((b[i][j]&&errorPos[i][j])||(b[i][j]&&!errorPos[i][j])){
					//user habe recognize,that the bit isn´t incorrect
					hilf[i][j]=1;////no change on this buttons
				}else if(b[i][j]==false&&errorPos[i][j]==false)
					hilf[i][j]=0;//button becomes green
				else if(b[i][j]==false&&errorPos[i][j]==true)
					hilf[i][j]=-1;//buttons becomes red, on this position isn´t an error
			}
		}
		return hilf;
	}
		
	public boolean[][] getPParity(int[][] guiP){
		/*if the user calculate the p-parity, this method checks if the solution is right */
		boolean[][] b=new boolean[p.length][p[0].length];
		for(int i=0;i<b.length;i++){
			for(int j=0;j<b[0].length;j++){
				if(guiP[i][j]==p[i][j])
					b[i][j]=true;
				else b[i][j]=false;
			}
		}
		return b;
	}
	
	public boolean[][] getQParity(int[][] guiQ){
		/*if the user calculate the q-parity, this method checks if the solution is right 
		  if parity-bit right b[i][j]=ture else false */
		boolean[][] b=new boolean[guiQ.length][guiQ[0].length];
		for(int i=0;i<b.length;i++){
			for(int j=0;j<b[0].length;j++){
				if(guiQ[i][j]==q[i][j])
					b[i][j]=true;
			}
		}
		return b;
	}
	
	public int[][] getSolution(){
		/*returns the solution matrix, info-matrix + p-/q-parity*/
		return solution;
	}
	
	public boolean[][] getErrorPos(){
		//returns the position of errors
		return errorPos;
	}
	
	private int[][] calcParity(int[][] a,int[][] b){
		return multiplyMatrix(a,b);
	}
	
	private int[][] multiplyMatrix(int[][] a,int[][] b){
		/* multiply 2 2-dimensional arrays */
		int[][] c=new int[a.length][b[0].length];
		for(int i=0;i<a.length;i++){
			for(int j=0;j<b[0].length;j++){
				for(int k=0;k<a[0].length;k++){
					c[i][j]+=(a[i][k]*b[k][j]);
				}
				c[i][j]%=2;
			}
		}
		return c;
	}
	
	private int[][] trans(int[][] a){
		/*transponiert matrix a */
		int[][] b=new int[a[0].length][a.length];
		for(int i=0;i<a.length;i++){
			for(int j=0;j<a[i].length;j++){
				b[j][i]=a[i][j];
			}
		}
		return b;
	}
	
	public boolean[][] test(String s,int[][] t){
		/* This method tests the calculated parity-bits. If user calculate a parity bit right,
		   this position is true else false. */
		boolean[][] b=new boolean[t.length][t[0].length];
		int[][] h;
		//if p-parity
		if(s.equals("P"))		//if p-parity
			h=p;
		else h=q;	//if q-parity
		for(int i=0;i<h.length;i++){
			for(int j=0;j<h[0].length;j++){
				if(h[i][j]==t[i][j])
					b[i][j]=true;
				else b[i][j]=false;
			}
		}
		return b;
	}
	
    public String getTime(){
    	/*This method calculate the needed time by user*/
		return Long.toString((System.currentTimeMillis()-time)/1000);
	}
	
}